meta-agl-core: update images in conf-notes.txt
[AGL/meta-agl.git] / scripts / .aglsetup_genconfig.bash
index c4dde42..3d380e6 100755 (executable)
@@ -4,7 +4,7 @@
 #
 # The MIT License (MIT)
 #
-# Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
+# Copyright (c) 2016-2019 Stéphane Desneux <sdx@iot.bzh>
 #           (c) 2016 Jan-Simon Möller <jsmoeller@linuxfoundation.org>
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # turn execute (source) generated instructions back in the parent shell,
 # whether it's bash, zsh, or any other supported shell
 
-VERSION=1.1.0
+VERSION=1.2.0
 DEFAULT_MACHINE=qemux86-64
 DEFAULT_BUILDDIR=./build
 VERBOSE=0
-DEBUG=0
+SHOWVERSION=0
+: ${DEBUG:=false}
 
 #SCRIPT=$(basename $BASH_SOURCE)
 SCRIPT=aglsetup.sh
@@ -46,12 +47,12 @@ function info() { echo "$@" >&2; }
 function infon() { echo -n "$@" >&2; }
 function error() { echo "ERROR: $@" >&2; return 1; }
 function verbose() { [[ $VERBOSE == 1 ]] && echo "$@" >&2; return 0; }
-function debug() { [[ $DEBUG == 1 ]] && echo "DEBUG: $@" >&2; return 0;}
+function debug() { $DEBUG && echo "DEBUG: $@" >&2; return 0;}
 
-info "------------ $SCRIPT: Starting"
+debug "------------ $SCRIPT: starting with command line arguments: $@"
 
 #compute AGL_REPOSITORIES
-AGL_REPOSITORIES=$(for x in $(ls -d $METADIR/meta-ag*/templates/{machine,feature} $METADIR/bsp/*/templates/machine); do echo $(basename $(dirname $(dirname $x))); done | sort -u)
+AGL_REPOSITORIES=$(for x in $(ls -d $METADIR/meta-*/templates/{machine,feature} $METADIR/bsp/*/templates/machine 2>/dev/null); do echo $(basename $(dirname $(dirname $x))); done | sort -u)
 
 function list_machines() {
        for a in $@; do
@@ -78,7 +79,7 @@ function validate_machines() {
        list_all_machines | sort | uniq -c | while read cnt machine; do
                [[ $cnt == 1 ]] && continue
                info "Machine $machine found in the following repositories:"
-               for x in $(ls -d $METADIR/*/templates/machine/$machine $METADIR/bsp/*/templates/machine/$machine ); do
+               for x in $(ls -d $METADIR/*/templates/machine/$machine $METADIR/bsp/*/templates/machine/$machine 2>/dev/null); do
                        info "   - $x"
                done
                error "Multiple machine templates are not allowed"
@@ -104,7 +105,7 @@ function validate_features() {
        list_all_features | sort | uniq -c | while read cnt feature; do
                [[ $cnt == 1 ]] && continue;
                info "Feature $feature found in the following repositories:"
-               for x in $(ls -d $METADIR/*/templates/feature/$feature ); do
+               for x in $(ls -d $METADIR/*/templates/feature/$feature 2>/dev/null); do
                        info "   - $x"
                done
                error "Multiple feature templates are not allowed"
@@ -115,7 +116,7 @@ function validate_features() {
 function find_machine_dir() {
        machine=$1
        for x in $AGL_REPOSITORIES; do
-               dirs=$(ls -d $METADIR/{.,bsp}/$x/templates/machine/$machine)
+               dirs=$(ls -d $METADIR/{.,bsp}/$x/templates/machine/$machine 2>/dev/null)
                for dir in $dirs; do
                    [[ -d $dir ]] && { echo $dir; return 0; }
                done
@@ -161,11 +162,22 @@ Options:
           'timestamp' : Use a generated time stamp (UTC).
           'value:<revision>' : Use <revision> explicitly.
           'none' : Do nothing.
+   -t|--topic <value>
+      Specify an optional topic for this setup.
+      If specified, the topic will be propagated in build manifests:
+         - in deployment dir: tmp/deploy/images/*/build-info
+         - in target image: /etc/platform-info/build
+         - in SDK: tmp/deploy/sdk/*.build-info
    -v|--verbose
       verbose mode
       default: false
+   -V|--version
+      display version, set AGLSETUP_VERSION variable with version value and exit
    -d|--debug
       debug mode
+      for early debug, set env variable DEBUG. 
+      for example:
+           DEBUG=true source aglsetup.sh -V
       default: false
    -h|--help
       get some help
@@ -211,21 +223,22 @@ function append_fragment() {
        echo >>$basefile
        echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
        echo "# fragment { " >>$basefile
-       [[ -f $f ]] && echo "# $f" >>$basefile || true
+       [[ -n $f ]] && echo "# $f" >>$basefile || true
        echo "#" >>$basefile
        [[ -n "$label" ]] && echo "$label" >>$basefile
-       [[ -f $f ]] && cat $f >>$basefile || true
+       [[ -n $f ]] && cat $f >>$basefile || true
+       echo "" >>$basefile
        echo "#" >>$basefile
        echo "# }" >>$basefile
        echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
-       [[ -f $f ]] && echo $f >>$BUILDDIR/conf/fragments.log || true
+       [[ -n $f ]] && echo $f >>$BUILDDIR/conf/fragments.log || true
 }
 
 function execute_setup() {
        script=$1
        debug "Executing script $script"
        opts="-e"
-       [[ $DEBUG == 1 ]] && opts="$opts -x"
+       $DEBUG && opts="$opts -x"
        pushd $BUILDDIR &>/dev/null
                $BASH $opts $script \
                        && rc=0 \
@@ -292,7 +305,7 @@ function find_feature_dependency() {
 
 GLOBAL_ARGS=( "$@" )
 debug "Parsing arguments: $@"
-TEMP=$(getopt -o m:b:r:s:fvdh --long machine:,builddir:,rpm-revision:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
+TEMP=$(getopt -o m:b:r:t:s:fvVdh --long machine:,builddir:,rpm-revision:,topic:,script:,force,verbose,version,debug,help -n $SCRIPT -- "$@")
 [[ $? != 0 ]] && { usage; exit 1; }
 eval set -- "$TEMP"
 
@@ -304,6 +317,7 @@ BUILDDIR=$DEFAULT_BUILDDIR
 SETUPSCRIPT=
 FORCE=
 RPMREVISION=
+TOPIC=
 SETUP_MANIFEST=aglsetup.manifest
 
 while true; do
@@ -313,8 +327,10 @@ while true; do
                -s|--setupscript)  SETUPSCRIPT=$2; shift 2;;
                -f|--force)        FORCE=1; shift;;
                -r|--rpm-revision) RPMREVISION=$2; shift 2;;
+               -t|--topic)        TOPIC=$2; shift 2;;
                -v|--verbose)      VERBOSE=1; shift;;
-               -d|--debug)        VERBOSE=1; DEBUG=1; shift;;
+               -V|--version)      SHOWVERSION=1; shift;;
+               -d|--debug)        VERBOSE=1; DEBUG=true; shift;;
                -h|--help)         HELP=1; shift;;
                --)                shift; break;;
                *) error "Arguments parsing error"; exit 1;;
@@ -323,6 +339,24 @@ done
 
 [[ "$HELP" == 1 ]] && { usage; exit 0; }
 
+if [[ "$SHOWVERSION" == 1 ]]; then
+       # display version on stdout
+       echo "$VERSION"
+
+       # generate output script if requested by caller
+       if [[ -n "$SETUPSCRIPT" ]]; then
+               cat <<EOF >$SETUPSCRIPT
+AGLSETUP_VERSION=$VERSION
+EOF
+       fi
+
+       # IMPORTANT: exit successfully
+       # older aglsetup scripts with version <1.2.0 will fail with option --version
+       exit 0
+fi
+
+info "------------ $SCRIPT: Starting"
+
 verbose "Command line arguments: ${GLOBAL_ARGS[@]}"
 
 # the remaining args are the features
@@ -373,7 +407,7 @@ function genconfig() {
        info "   Features: $FEATURES"
 
        # step 1: run usual OE setup to generate conf dir
-       export TEMPLATECONF=$(cd $SCRIPTDIR/../templates/base && pwd -P)
+       export TEMPLATECONF=$(cd $SCRIPTDIR/../meta-agl-core/conf/templates/base && pwd -P)
        debug "running oe-init-build-env with TEMPLATECONF=$TEMPLATECONF"
        info "   Running $METADIR/external/poky/oe-init-build-env"
        info "   Templates dir: $TEMPLATECONF"
@@ -383,7 +417,8 @@ function genconfig() {
        cd $CURDIR
 
        # step 2: concatenate other remaining fragments coming from base
-       process_fragments $TEMPLATECONF
+       FRAGMENTS=$(cd $SCRIPTDIR/../templates/base && pwd -P)
+       process_fragments $FRAGMENTS
 
        # step 3: fragments for machine
        process_fragments $(find_machine_dir $MACHINE)
@@ -462,6 +497,7 @@ EOF
 [[ $FORCE -eq 1 ]] && rm -f \
        $BUILDDIR/conf/local.conf \
        $BUILDDIR/conf/bblayers.conf \
+       $BUILDDIR/conf/templateconf.cfg \
        $BUILDDIR/conf/setup.* \
        $BUILDDIR/conf/*.log
 
@@ -509,6 +545,9 @@ DIST_METADIR="$METADIR"
 # timestamp
 DIST_SETUP_TS="$(date -u +%Y%m%d_%H%M%S_%Z)"
 
+# topic
+DIST_SETUP_TOPIC="$TOPIC"
+
 # ------------ end of $SCRIPT fragment --------
 EOF
 info "OK"
@@ -519,14 +558,15 @@ info "OK"
 infon "Generating setup file: $BUILDDIR/agl-init-build-env ... "
 
 cat <<EOF >$BUILDDIR/agl-init-build-env
+export TEMPLATECONF=${METADIR}/meta-agl/meta-agl-core/conf/templates/base
 . $METADIR/external/poky/oe-init-build-env $BUILDDIR
 if [ -n "\$DL_DIR" ]; then
-       BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE DL_DIR"
+       BB_ENV_PASSTHROUGH_ADDITIONS="\$BB_ENV_PASSTHROUGH_ADDITIONS DL_DIR"
 fi
 if [ -n "\$SSTATE_DIR" ]; then
-       BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE SSTATE_DIR"
+       BB_ENV_PASSTHROUGH_ADDITIONS="\$BB_ENV_PASSTHROUGH_ADDITIONS SSTATE_DIR"
 fi
-export BB_ENV_EXTRAWHITE
+export BB_ENV_PASSTHROUGH_ADDITIONS
 unset TEMPLATECONF
 EOF
 info "OK"